# -*- coding: utf-8 -*-
# Generated by Django 1.10.7 on 2017-06-28 13:34
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion
import ucs_besplusplus.models

def create_initial_data(apps, schema_editor):
    # These are fundamental resources that have to be in the database.
    Resource = apps.get_model("ucs_besplusplus", "Resource")
    db_alias = schema_editor.connection.alias
    Resource.objects.using(db_alias).bulk_create([
        Resource("type"),
        Resource("property"),
        Resource("class"),
    ])
    Property = apps.get_model("ucs_besplusplus", "Property")
    Property.objects.using(db_alias).bulk_create([
        Property(subject=Resource("type"),
                 proposition=Resource("type"),
                 object_res=Resource("property")),
        Property(subject=Resource("class"),
                 proposition=Resource("type"),
                 object_res=Resource("class")),
        Property(subject=Resource("property"),
                 proposition=Resource("type"),
                 object_res=Resource("class")),
    ])

class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='HistoryRecord',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('when', models.DateTimeField(auto_now_add=True, db_index=True)),
                ('who', models.CharField(blank=True, max_length=256)),
                ('how', models.TextField(blank=True)),
                ('deleted', models.BooleanField(default=None)),
                ('object_lit', models.CharField(blank=True, max_length=1024, null=True)),
            ],
            options={
                'ordering': ['-when'],
            },
        ),
        migrations.CreateModel(
            name='Property',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('object_lit', models.CharField(blank=True, max_length=1024, null=True)),
            ],
            options={
                'verbose_name_plural': 'properties',
            },
        ),
        migrations.CreateModel(
            name='Resource',
            fields=[
                ('id', models.CharField(default=ucs_besplusplus.models.struuid4, max_length=256, primary_key=True, serialize=False)),
            ],
        ),
        migrations.AddField(
            model_name='property',
            name='object_res',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='properties_rev', to='ucs_besplusplus.Resource'),
        ),
        migrations.AddField(
            model_name='property',
            name='proposition',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='properties_sideways', to='ucs_besplusplus.Resource'),
        ),
        migrations.AddField(
            model_name='property',
            name='subject',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='properties_fwd', to='ucs_besplusplus.Resource'),
        ),
        migrations.AddField(
            model_name='historyrecord',
            name='object_res',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='ucs_besplusplus.Resource'),
        ),
        migrations.AddField(
            model_name='historyrecord',
            name='property',
            field=models.ForeignKey(db_constraint=False, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='ucs_besplusplus.Property'),
        ),
        migrations.AddField(
            model_name='historyrecord',
            name='proposition',
            field=models.ForeignKey(db_constraint=False, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='ucs_besplusplus.Resource'),
        ),
        migrations.AddField(
            model_name='historyrecord',
            name='subject',
            field=models.ForeignKey(db_constraint=False, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='ucs_besplusplus.Resource'),
        ),
        migrations.AlterUniqueTogether(
            name='property',
            unique_together=set([('subject', 'proposition', 'object_res', 'object_lit')]),
        ),
        migrations.RunPython(create_initial_data),
    ]
